## pam 1.5.2

=== debian/changelog ===
pam (1.5.2-6+rpt2+deb12u1) bookworm; urgency=medium

  * Remove pam-chkpasswd from libpam-modules package
  * Merge changes from Pi bullseye version

 -- Simon Long <simon@raspberrypi.com>  Wed, 11 Oct 2023 11:35:23 +0100

pam (1.5.2-6+deb12u1) bookworm; urgency=medium

  * Fix pam-auth-update --disable logic error, Closes: #1039873
  * Set myself as maintainer; thanks Steve for past and future work.
  * Updated Turkish Debconf translations, Thanks Atila KOÇ, Closes: #1029002

 -- Sam Hartman <hartmans@debian.org>  Thu, 21 Sep 2023 14:55:12 -0600

pam (1.5.2-6) unstable; urgency=medium

  * Update debian/copyright, Thanks Bastian Germann, Closes: #460232
  * When pam-auth-update is called with --root,  use
    /usr/share/pam-configs from the root not from the host system, Thanks
    Johannes Schauer Marin Rodrigues, Closes: #1022952
  * Build-depend on libcrypt-dev, Closes: #1024645
  *  Add pam-auth-udpate --disable, Closes: #1004000
  * Add autopkgtests

 -- Sam Hartman <hartmans@debian.org>  Tue, 03 Jan 2023 13:15:23 -0700

pam (1.5.2-5) unstable; urgency=medium

  * pam_namespace_helper manpage *wasn't* missing, it was just being
    wrongly shipped in libpam-modules instead - so complete the moving
    of the manpage to the libpam-modules-bin where it belongs with the
    binary.  Really Closes: #1021336.

 -- Steve Langasek <vorlon@debian.org>  Thu, 06 Oct 2022 18:56:06 +0000

pam (1.5.2-4) unstable; urgency=medium

  * pam_namespace_helper manpage was missing, but namespace.conf.5 was
    already shipped in libpam-modules.  Leave it there.  Closes: #1021336.

 -- Steve Langasek <vorlon@debian.org>  Thu, 06 Oct 2022 17:28:36 +0000

pam (1.5.2-3) unstable; urgency=medium

  * Add missing manpages for pam_namespace which for some reason don't get
    installed by the upstream rules
  * Drop obsolete upgrade code from maintainer scripts which is no longer
    used
  * Drop manual multiarch file handling in favor of dh-exec.
  * No special-case needed for pam_modutil_sanitize_helper_fds in symbols
    file, it's covered by the existing globs.
  * debian/local/Debian-PAM-MiniPolicy: drop references to ancient
    package versions.  Thanks, Marc Haber.
  * Support DPKG_ROOT in the postinst scripts.  Closes: #993161.
    Thanks, Johannes Schauer Marin Rodrigues.
  * Further proof libpam-runtime postinst for DPKG_ROOT just in case.

 -- Steve Langasek <vorlon@debian.org>  Thu, 06 Oct 2022 04:05:02 +0000

pam (1.5.2-2) unstable; urgency=medium

  * Pass --with-systemdunitdir=/usr/lib/systemd/system for consistent
    builds whether we are or aren't building in an environment with systemd
    present.
  * Install the pam_namespace.service unit in the libpam-modules-bin
    package.

 -- Steve Langasek <vorlon@debian.org>  Thu, 18 Aug 2022 16:47:57 +0000

pam (1.5.2-1) unstable; urgency=medium

  * New upstream release.
    - fixes compatibility with libpam-systemd.  Closes: #1017467.
    - fixes bashisms in configure.ac.  Closes: #998361.
  * Refresh patches.
  * Drop patches included or obsoleted upstream:
    - debian/patches-applied/pam_unix_fix_sgid_shadow_auth.patch
    - debian/patches-applied/pam_unix_initialize_daysleft
    - debian/patches-applied/pam_faillock_create_directory
    - debian/patches-applied/pam_unix_avoid_checksalt
    - debian/patches-applied/pam_env-allow-environment-files-without-EOL-at-EOF.patch
  * Drop libpam-cracklib which has been obsoleted upstream.
  * Add pkgconfig .pc files to libpam0g-dev.  Closes: #1012688.
  * Update .symbols file.
  * Updated Romanian debconf translation, thanks Andrei Popescu, Closes:
    #986416
  * Drop versioning of quilt build-dependency to quiet lintian, since the
    version is satisfied by oldoldoldstable.
  * Drop unused build-build-dependency on bzip2.
  * Adjust lintian overrides for latest lintian syntax.
  * Update Standards-Version.
  * Bump debhelper compat to 13.
  * debian/not-installed: document upstream files that aren't used.
  * Override incorrect lintian warning about use of dpkg database.
  * Override lintian warning for PAM module manpages being in section 8
  * Override lintian warning for unused debconf templates
  * Install additional upstream manpages: faillock(8), environment(5),
    pwhistory_helper(8)
  * Install additional helpers in libpam-modules-bin: pam_namespace_helper,
    pwhistory_helper
  * Fix wrong syntax in symbols file

 -- Steve Langasek <vorlon@debian.org>  Thu, 18 Aug 2022 07:27:16 +0000

pam (1.4.0-13) unstable; urgency=medium

  * Don't build with NIS support.  This is only used for password changes on
    NIS systems, and is pulling a large dependency chain into the Essential
    package set which is not justifiable.

 -- Steve Langasek <vorlon@debian.org>  Mon, 25 Apr 2022 16:12:04 -0700

=== debian/control ===
Source: pam
Section: libs
Priority: optional
Maintainer: Sam Hartman <hartmans@debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>
Standards-Version: 4.6.0
Build-Depends: debhelper-compat (= 13), dh-exec, quilt, flex, libdb-dev, libcrypt-dev, libselinux1-dev [linux-any], po-debconf, dh-autoreconf, autopoint, libaudit-dev [linux-any] <!stage1>, pkg-config, libfl-dev, libfl-dev:native, docbook-xsl, docbook-xml, xsltproc, libxml2-utils, w3m
Build-Conflicts-Indep: fop
Build-Conflicts: libdb4.2-dev, libxcrypt-dev
Vcs-Browser: https://salsa.debian.org/vorlon/pam
Vcs-Git: https://salsa.debian.org/vorlon/pam.git
Homepage: http://www.linux-pam.org/
Rules-Requires-Root: binary-targets

Package: libpam0g
Architecture: any
Multi-Arch: same
Replaces: libpam0g-util
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libpam-doc
Description: Pluggable Authentication Modules library
 Contains the shared library for Linux-PAM, a library that enables the
 local system administrator to choose how applications authenticate users.
 In other words, without rewriting or recompiling a PAM-aware application,
 it is possible to switch between the authentication mechanism(s) it uses.
 One may entirely upgrade the local authentication system without touching
 the applications themselves.

Package: libpam-modules
Section: admin
Priority: required
Architecture: any
Multi-Arch: same
Pre-Depends: ${shlibs:Depends}, ${misc:Depends},
	libpam-modules-bin (= ${binary:Version})
Conflicts: libpam-motd, libpam-mkhomedir, libpam-umask
Replaces: libpam0g-util, libpam-umask
Provides: libpam-motd, libpam-mkhomedir, libpam-umask
Description: Pluggable Authentication Modules for PAM
 This package completes the set of modules for PAM. It includes the
  pam_unix.so module as well as some specialty modules.

Package: libpam-modules-bin
Section: admin
Priority: required
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libpam-modules (<< 1.5.2-5~)
Description: Pluggable Authentication Modules for PAM - helper binaries
 This package contains helper binaries used by the standard set of PAM
 modules in the libpam-modules package.

Package: libpam-runtime
Section: admin
Priority: required
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, debconf (>= 1.5.19) | cdebconf, libpam-modules (>= 1.0.1-6)
Replaces: libpam0g-util, libpam0g-dev
Conflicts: libpam0g-util
Description: Runtime support for the PAM library
 Contains configuration files and  directories required for
 authentication  to work on Debian systems.  This package is required
 on almost all installations.

Package: libpam0g-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libpam0g (= ${binary:Version}), libc6-dev|libc-dev
Provides: libpam-dev
Description: Development files for PAM
 Contains C header files and development libraries for libpam, the Pluggable
 Authentication Modules, a library that enables the local system
 administrator to choose how applications authenticate users.
 .
 PAM decouples applications from the authentication mechanism, making it
 possible to upgrade the authentication system without recompiling or
 rewriting the applications.

Package: libpam-doc
Provides: pam-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation of PAM
 Contains documentation (in HTML, ASCII, and PostScript format) for libpam,
 the Pluggable Authentication Modules library, a library that enables the
 local system administrator to choose how applications authenticate users.

Package: libpam-chksshpwd
Section: admin
Priority: optional
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libpam0g, libpam-runtime, gettext-base
Description: PAM module to enable SSH password checking support
 This package includes libpam_chkpasswd, a PAM module that checks to see
 if the default password has been changed when SSH is enabled.

=== debian/rules ===
#!/usr/bin/make -f

DEB_LDFLAGS_MAINT_APPEND := -Wl,-z,defs
DEB_CFLAGS_MAINT_APPEND  := $(shell getconf LFS_CFLAGS)
DEB_BUILD_MAINT_OPTIONS  := hardening=+bindnow
export DEB_LDFLAGS_MAINT_APPEND DEB_CFLAGS_MAINT_APPEND DEB_BUILD_MAINT_OPTIONS
ifeq ($(shell dpkg-architecture -qDEB_BUILD_ARCH_OS),hurd)
DEB_LDFLAGS_MAINT_APPEND += -lpthread
endif

DEB_HOST_MULTIARCH	?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

LC_COLLATE=C
export LC_COLLATE

export QUILT_PATCH_DIR = debian/patches-applied

d = $(CURDIR)/debian
dl = $(d)/local

%:
	dh $@ --with quilt,autoreconf

# avoid libaudit-dev when bootstrapping
ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
  CONFIGURE_OPTS += --disable-audit
endif  

override_dh_auto_configure:
	dh_auto_configure -- --enable-static --enable-shared \
		--libdir=/lib/$(DEB_HOST_MULTIARCH) \
		--enable-isadir=/lib/security \
		--with-systemdunitdir=/usr/lib/systemd/system \
		--disable-nis \
		$(CONFIGURE_OPTS)

# .install files don't have "except for" handling, so we need to exclude
# our module that doesn't match right here
override_dh_install:
ifneq (,$(findstring libpam-modules, $(shell dh_listpackages)))
	dh_install -plibpam-modules -Xpam_chksshpwd
endif
	dh_install -Nlibpam-modules
	# Make sure the md5sums for the templates we ship are
	# recognized by pam-auth-update.
	for f in common-auth common-session common-session-noninteractive common-account common-password; do \
	if grep -q $$(perl debian/template-md5sum debian/local/$$f ) debian/local/pam-auth-update; then \
	    echo $$f okay; \
	else \
	    echo md5sum for $$f not registered in debian/local/pam-auth-update; \
	    echo use debian/template-md5sum to compute; \
	    exit 2; \
	fi; \
	done



# again, excluding files by hand; also, build our local manpage for pam_getenv
# from the XML
override_dh_installman:
	pod2man --section 8 --release="Debian GNU/Linux" $(dl)/pam_getenv >$(dl)/pam_getenv.8
	dh_installman
	rm -f $(d)/libpam-modules/usr/share/man/man5/pam.conf.5
	rm -f $(d)/libpam-modules/usr/share/man/man8/pam_chksshpwd.8
	rm -f $(d)/libpam-modules/usr/share/man/man8/pam_timestamp_check.8
	rm -f $(d)/libpam-modules/usr/share/man/man8/pam_namespace_helper.8

# using perms that differ from upstream (sgid instead of suid) /and/ that
# dh_fixperms doesn't want
override_dh_fixperms:
	dh_fixperms
ifneq (,$(findstring libpam-modules, $(shell dh_listpackages)))
	chgrp shadow $(d)/libpam-modules-bin/sbin/unix_chkpwd
	chmod 02755 $(d)/libpam-modules-bin/sbin/unix_chkpwd
endif

## pam 1.5.3

=== debian/changelog ===
pam (1.5.3-7ubuntu4.4) plucky-security; urgency=medium

  * SECURITY UPDATE: pam_access hostname confusion
    - debian/patches/CVE-2024-10963.patch: add "nodns" option to disallow
      resolving of tokens as hostname in
      modules/pam_access/access.conf.5.xml,
      modules/pam_access/pam_access.8.xml,
      modules/pam_access/pam_access.c.
    - CVE-2024-10963

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 15 Sep 2025 08:28:47 -0400

pam (1.5.3-7ubuntu4.3) plucky-security; urgency=medium

  * SECURITY UPDATE: privilege escalation via pam_namespace
    - debian/patches/pam_namespace_170.patch: sync pam_namespace module to
      version 1.7.0.
    - debian/patches/pam_namespace_post170-*.patch: add post-1.7.0 changes
      from upstream git tree.
    - debian/patches/pam_namespace_revert_abi.patch: revert ABI change to
      prevent unintended issues in running daemons.
    - debian/patches/CVE-2025-6020-1.patch: fix potential privilege
      escalation.
    - debian/patches/CVE-2025-6020-2.patch: add flags to indicate path
      safety.
    - debian/patches/CVE-2025-6020-3.patch: secure_opendir: do not look at
      the group ownership.
    - debian/patches/pam_namespace_o_directory.patch: removed, included in
      patch cluster above.
    - CVE-2025-6020

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 12 Jun 2025 10:45:28 -0400

pam (1.5.3-7ubuntu4.1) plucky; urgency=medium

  * d/p/031_pam_include: fix loading from /usr/lib/pam.d (LP: #2087827)

 -- Simon Chopin <schopin@ubuntu.com>  Mon, 26 May 2025 15:33:44 +0200

pam (1.5.3-7ubuntu4) plucky; urgency=medium

  * debian/pam-configs/mkhomedir: remove umask override added previously
    for LP#1957024 as this is not actually needed since pam_mkhomedir
    already respects HOME_MODE from login.defs and it complicates umask
    management in general

 -- Alex Murray <alex.murray@canonical.com>  Wed, 20 Nov 2024 06:43:46 +1030

pam (1.5.3-7ubuntu3) plucky; urgency=medium

  [ Ponnuvel Palaniyappan ]
  * debian/pam-configs/mkhomedir: honor default private home directory
    permissions for pam_mkdir.so by specifying a umask of 0027
    (LP: #1957024)

 -- Alex Murray <alex.murray@canonical.com>  Thu, 07 Nov 2024 13:29:20 +1030

pam (1.5.3-7ubuntu2) oracular; urgency=medium

  * debian/patches/fix-pam_motd_ftbfs.patch: fix FTBFS in display_legal()

 -- Nishit Majithia <nishit.majithia@canonical.com>  Fri, 16 Aug 2024 14:53:00 +0530

pam (1.5.3-7ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - debian/libpam-modules.postinst: Add PATH to /etc/environment if it's
      not present there or in /etc/security/pam_env.conf. (should send to
      Debian).
    - debian/libpam0g.postinst: only ask questions during update-manager
      when there are non-default services running.
    - debian/libpam0g.postinst: check if gdm is actually running before
      trying to reload it.
    - debian/patches/ubuntu-rlimit_nice_correction: Explicitly
      initialise RLIMIT_NICE rather than relying on the kernel limits.
    - debian/patches/pam_umask_usergroups_from_login.defs.patch:
      Deprecate pam_unix's explicit "usergroups" option and instead read it
      from /etc/login.def's "USERGROUP_ENAB" option if umask is only defined
      there. This restores compatibility with the pre-PAM behaviour of login.
    - debian/patches/pam_motd-legal-notice: display the contents of
      /etc/legal once, then set a flag in the user's homedir to prevent
      showing it again.
    - debian/update-motd.5, debian/libpam-modules.manpages: add a manpage
      for update-motd, with some best practices and notes of explanation.
    - debian/patches/update-motd-manpage-ref: add a reference in pam_motd(8)
      to update-motd(5)
    - debian/local/common-session{,-noninteractive}: Enable pam_umask by
      default, now that the umask setting is gone from /etc/profile.
    - debian/local/pam-auth-update: Add the new md5sums for pam_umask addition.
    - debian/patches/extrausers.patch: Add a pam_extrausers module
      that is basically just a copy of pam_unix but looks at
      /var/lib/extrausers/{group,passwd,shadow} instead of /etc/
    - debian/libpam-modules-bin.install: install the helper binaries for
      pam_extrausers to /sbin
    - debian/rules: Make pam_extrausers_chkpwd sguid shadow
    - Add lintian override for pam_extrausers_chkpwd
    - Disable custom daemon restart detection code if needrestart is available
    - d/p/pam_env-remove-deprecation-notice-for-user_readenv.patch: drop
      deprecation warning about user_readenv from pam_env (LP 2059859)

 -- Dan Bungert <daniel.bungert@canonical.com>  Tue, 30 Apr 2024 16:17:36 -0600

pam (1.5.3-7) unstable; urgency=medium

  * Correct Build depends for docbook5, Closes: #1065064
  * Regenerate patches to capture date change in pam_getitem.3
  * Depend on libdb-dev again, bringing back pam_userdb, Closes: #1065088
  * Document pam_umask change, Closes: #1065806

 -- Sam Hartman <hartmans@debian.org>  Mon, 08 Apr 2024 16:35:07 -0600

pam (1.5.3-6) unstable; urgency=medium

  [ Dan Bungert ]
  * Fix FTBFS when built with -Werror=implicit-function-declaration

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 12:56:32 -0800

pam (1.5.3-5ubuntu5) noble; urgency=medium

  * d/p/pam_env-remove-deprecation-notice-for-user_readenv.patch: drop
    deprecation warning about user_readenv from pam_env (LP: #2059859)

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 10 Apr 2024 16:19:22 -0300

pam (1.5.3-5ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:03:23 +0000

pam (1.5.3-5ubuntu3) noble; urgency=medium

  * No-change rebuild against libdb5.3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 02 Mar 2024 20:36:06 +0000

pam (1.5.3-5ubuntu2) noble; urgency=medium

  * Fix FTBFS when built with -Werror=implicit-function-declaration


=== debian/rules ===
--- 
+++ 
@@ -13,34 +13,37 @@
 LC_COLLATE=C
 export LC_COLLATE
 
-export QUILT_PATCH_DIR = debian/patches-applied
 
 d = $(CURDIR)/debian
 dl = $(d)/local
 
 %:
-	dh $@ --with quilt,autoreconf
+	dh $@
+
 
 # avoid libaudit-dev when bootstrapping
 ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
   CONFIGURE_OPTS += --disable-audit
-endif  
+endif
+
+CONFIGURE_OPTS += --enable-logind
 
 override_dh_auto_configure:
+	# Explicitly set libdir, sbindir to avoid upstream's override logic.
 	dh_auto_configure -- --enable-static --enable-shared \
-		--libdir=/lib/$(DEB_HOST_MULTIARCH) \
-		--enable-isadir=/lib/security \
+		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
+		--sbindir=/usr/sbin \
+		--enable-isadir=/usr/lib/security \
 		--with-systemdunitdir=/usr/lib/systemd/system \
 		--disable-nis \
+		--enable-usergroups \
 		$(CONFIGURE_OPTS)
+	chmod 775 modules/pam_faillock/tst-pam_faillock
 
 # .install files don't have "except for" handling, so we need to exclude
 # our module that doesn't match right here
 override_dh_install:
-ifneq (,$(findstring libpam-modules, $(shell dh_listpackages)))
-	dh_install -plibpam-modules -Xpam_chksshpwd
-endif
-	dh_install -Nlibpam-modules
+	dh_install
 	# Make sure the md5sums for the templates we ship are
 	# recognized by pam-auth-update.
 	for f in common-auth common-session common-session-noninteractive common-account common-password; do \
@@ -61,7 +64,6 @@
 	pod2man --section 8 --release="Debian GNU/Linux" $(dl)/pam_getenv >$(dl)/pam_getenv.8
 	dh_installman
 	rm -f $(d)/libpam-modules/usr/share/man/man5/pam.conf.5
-	rm -f $(d)/libpam-modules/usr/share/man/man8/pam_chksshpwd.8
 	rm -f $(d)/libpam-modules/usr/share/man/man8/pam_timestamp_check.8
 	rm -f $(d)/libpam-modules/usr/share/man/man8/pam_namespace_helper.8
 
@@ -70,6 +72,11 @@
 override_dh_fixperms:
 	dh_fixperms
 ifneq (,$(findstring libpam-modules, $(shell dh_listpackages)))
-	chgrp shadow $(d)/libpam-modules-bin/sbin/unix_chkpwd
-	chmod 02755 $(d)/libpam-modules-bin/sbin/unix_chkpwd
+	chgrp shadow $(d)/libpam-modules-bin/usr/sbin/unix_chkpwd
+	chmod 02755 $(d)/libpam-modules-bin/usr/sbin/unix_chkpwd
+	chgrp shadow $(d)/libpam-modules-bin/usr/sbin/pam_extrausers_chkpwd
+	chmod 02755 $(d)/libpam-modules-bin/usr/sbin/pam_extrausers_chkpwd
 endif
+
+override_dh_installchangelogs:
+	dh_installchangelogs NEWS

=== debian/watch ===
 version=4
 opts=searchmode=plain,pgpmode=auto \
 https://api.github.com/repos/linux-pam/linux-pam/releases \
 https://github.com/linux-pam/linux-pam/releases/download/v?[\d.]+/Linux-PAM-([\d.]+)@ARCHIVE_EXT@

## pam 1.7.0

=== meson_options.txt ===
# -*- mode: meson -*-

option('i18n', type: 'feature', value: 'auto',
       description: 'i18n support')
option('docs', type: 'feature', value: 'auto',
       description: 'Generate and install documentation')
option('audit', type: 'feature', value: 'auto',
       description: 'audit support')
option('econf', type: 'feature', value: 'auto',
       description: 'libeconf support')
option('logind', type: 'feature', value: 'auto',
       description: 'logind support in pam_issue and pam_timestamp')
option('openssl', type: 'feature', value: 'disabled',
       description: 'Use OpenSSL crypto libraries in pam_timestamp')
option('selinux', type: 'feature', value: 'auto',
       description: 'SELinux support')
option('nis', type: 'feature', value: 'auto',
       description: 'NIS/YP support in pam_unix')

option('examples', type: 'boolean', value: true,
       description: 'Build examples')
option('lckpwdf', type: 'boolean', value: true,
       description: 'Use lckpwdf function in pam_unix')
option('pam-debug', type: 'boolean', value: false,
       description: 'Save debugging information into pam-debug.log')
option('pamlocking', type: 'boolean', value: false,
       description: 'Observe a global authentication lock')
option('read-both-confs', type: 'boolean', value: false,
       description: 'Read both /etc/pam.d and /etc/pam.conf files')
option('usergroups', type: 'boolean', value: false,
       description: 'usergroups option default in pam_umask')
option('xtests', type: 'boolean', value: false,
       description: 'Build xtests')

option('misc-conv-bufsize', type: 'integer', value: 4096,
       description: 'Size of input buffer for misc_conv() conversation function')
option('kernel-overflow-uid', type: 'integer', value: 65534,
       description: 'Linux kernel overflow uid')
option('uidmin', type: 'integer', value: 1000,
       description: 'Default value for regular user min uid')

option('docbook-rng',
       type: 'string',
       value: 'http://docbook.org/xml/5.0/rng/docbookxi.rng',
       description: 'RNG file for checking XML files')
option('html-stylesheet',
       type: 'string',
       value: 'http://docbook.sourceforge.net/release/xsl-ns/current/html/chunk.xsl',
       description: 'html stylesheet path')
option('man-stylesheet',
       type: 'string',
       value: 'http://docbook.sourceforge.net/release/xsl-ns/current/manpages/profile-docbook.xsl',
       description: 'man stylesheet path')
option('pdf-stylesheet',
       type: 'string',
       value: 'http://docbook.sourceforge.net/release/xsl-ns/current/fo/docbook.xsl',
       description: 'pdf stylesheet path')
option('txt-stylesheet',
       type: 'string',
       value: 'http://docbook.sourceforge.net/release/xsl-ns/current/html/docbook.xsl',
       description: 'txt stylesheet path')
option('xml-catalog', type: 'string',
       description: 'xml catalog path')

option('docdir', type: 'string',
       description: 'documentation directory')
option('htmldir', type: 'string',
       description: 'HTML documentation directory')
option('pdfdir', type: 'string',
       description: 'PDF documentation directory')

option('isadir', type: 'string',
       description: 'Arch-specific PAM modules directory, relative to SECUREDIR')
option('securedir', type: 'string',
       description: 'PAM modules directory')
option('sconfigdir', type: 'string',
       description: 'PAM module configuration files directory')
option('systemdunitdir', type: 'string',
       description: 'systemd service directory')
option('mailspool', type: 'string',
       description: 'Mail spool directory')
option('xauth', type: 'string',
       description: 'Additional path to check for xauth when it is called from pam_xauth')
option('randomdev', type: 'string',
       description: 'Random device to use instead of /dev/urandom')
option('vendordir', type: 'string',
       description: 'Distribution provided configuration files directory')

option('pam_userdb', type: 'feature', value: 'auto',
       description: 'pam_userdb module')
option('db', type: 'combo', choices: ['db', 'gdbm', 'ndbm', 'auto'],
       value: 'auto')
option('db-uniquename', type: 'string',
       description: 'Unique name for db libraries and functions')

option('pam_lastlog', type: 'feature', value: 'disabled',
       description: 'pam_lastlog module')
option('pam_unix', type: 'feature', value: 'auto',
       description: 'pam_unix module')

=== debian/changelog ===
pam (1.7.0-5ubuntu2) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Sat, 06 Sep 2025 15:08:48 +0000

pam (1.7.0-5ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2112053). Remaining changes:
    - debian/libpam-modules.postinst: Add PATH to /etc/environment if it's
      not present there or in /etc/security/pam_env.conf. (should send to
      Debian).
    - debian/libpam0g.postinst: only ask questions during update-manager
      when there are non-default services running.
    - debian/libpam0g.postinst: check if gdm is actually running before
      trying to reload it.
    - debian/patches/pam_motd-legal-notice: display the contents of
      /etc/legal once, then set a flag in the user's homedir to prevent
      showing it again.
    - debian/patches/ubuntu-rlimit_nice_correction: Explicitly
      initialise RLIMIT_NICE rather than relying on the kernel limits.
    - debian/update-motd.5, debian/libpam-runtime.manpages: add a manpage
      for update-motd, with some best practices and notes of explanation.
    - debian/patches/update-motd-manpage-ref: add a reference in pam_motd(8)
      to update-motd(5)
    - debian/local/common-session{,-noninteractive}: Enable pam_umask by
      default, now that the umask setting is gone from /etc/profile.
    - debian/local/pam-auth-update: Add the new md5sums for pam_umask addition.
    - debian/patches/extrausers.patch: Add a pam_extrausers module
      that is basically just a copy of pam_unix but looks at
      /var/lib/extrausers/{group,passwd,shadow} instead of /etc/
    - debian/libpam-modules-bin.install: install the helper binaries for
      pam_extrausers to /sbin
    - debian/rules: Make pam_extrausers_chkpwd sguid shadow
    - Add lintian override for pam_extrausers_chkpwd
    - Disable custom daemon restart detection code if needrestart is available
    - d/p/pam_env-remove-deprecation-notice-for-user_readenv.patch: drop
      deprecation warning about user_readenv from pam_env (LP 2059859)
    - debian/patches/pam_umask_usergroups_from_login.defs.patch:
      Deprecate pam_unix's explicit "usergroups" option and instead read it
      from /etc/login.def's "USERGROUP_ENAB" option if umask is only defined
      there. This restores compatibility with the pre-PAM behaviour of login.
    - d/po/eu.po, d/po/fi.po, d/po/vi.po: Clean-up translation files
    - debian/patches/fix-pam_motd_ftbfs.patch: fix FTBFS in display_legal()
    - d/p/031_pam_include: fix loading from /usr/lib/pam.d (LP #2087827)
  * Drop Changes:
    - debian/pam-configs/mkhomedir: honor default private home directory
      permissions for pam_mkdir.so by specifying a umask of 0027
      (LP #1957024)
      [Dropped the above change and its revert below]
    - debian/pam-configs/mkhomedir: remove umask override added previously
      for LP #1957024 as this is not actually needed since pam_mkhomedir
      already respects HOME_MODE from login.defs and it complicates umask
      management in general
    - SECURITY UPDATE: privilege escalation via pam_namespace
      [Fixed in 1.7.0-4]
  * Changed Delta:
    - d/p/extrausers.patch,
      d/p/pam_umask_usergroups_from_login.defs.patch,
      d/p/update-motd-manpage-ref: Update patches to work with meson. Drop
      text-based man-pages in favor of XML ones. Add required code to build
      scripts.
    - debian/tests/usr-lib-config: Fix typo in "mv /usr/lib/pam.d/passwd
      /etc/pam.d/*"

 -- Ankush Pathak <ankush.pathak@canonical.com>  Thu, 03 Jul 2025 22:03:16 +0530

pam (1.7.0-5) unstable; urgency=high

  * pam_access: backport upstream commit to implement nodns option to allow people to work around #1087019

 -- Sam Hartman <hartmans@debian.org>  Sun, 29 Jun 2025 11:40:46 -0600

pam (1.7.0-4) experimental; urgency=high

  [ Gioele Barabucci ]
  * d/control: Update standards version to 4.7.0, no changes needed
  * d/TODO: Remove outdated item about fop (Closes: #629438)

  [ Sam Hartman ]
  * Fix CVE-2025-6020: local privilege escalation in pam_namespace, Closes: 1107919

  [ James Morris ]
  * pam_access improperly checks for group membership of a user.
    (Closes: #1103339)

 -- Sam Hartman <hartmans@debian.org>  Thu, 26 Jun 2025 11:42:58 -0600

pam (1.7.0-3) unstable; urgency=high

  * Disable HURD suid patch for now because it breaks on Linux, Closes:
    #1095194

 -- Sam Hartman <hartmans@debian.org>  Tue, 11 Feb 2025 05:19:04 -0700

pam (1.7.0-2) unstable; urgency=medium

  * Release to unstable

 -- Sam Hartman <hartmans@debian.org>  Wed, 29 Jan 2025 18:58:07 -0700

pam (1.7.0-1) experimental; urgency=medium

  * New upstream version, Closes: #1088923
    - ChangeLog removed upstream, do not install it.
    - Upstream claims CVE-2024-10041 is fixed by PAM 1.6.0, Closes:
      #1086038
  * Build depend on meson
  * Depend on fop
  * Use installed faillock and namespace man page rather than source man page.
  * Install text module documentation in libpam-doc/txt
  * Build and install pdf documentation
  * Remove Steve from uploaders, thanks for all your contributions; you
    will be missed.
  * In response to lintian complaint, clarify that PAM can be distributed under any version of the GPL.
  * Pdf files are compressed; update doc-base
  * Properly handle environment.5 manpage, Closes: #1081181
  * Move pam module man pages into libpam-runtime to avoid  multi-arch uninstallability
  * Move libpam0g-dev man pages into libpam-doc
  * Build depend on pkgconf rather than pkg-config
  * Only build-depend on documentation tools for arch-indep builds; do not build docs for arch all builds, Closes: #1093222
  * pam_limits: do not override systemd's limits by default; add the set_all option to restore previous behavior, Closes: #995236
  * Document pam_limits change in news

 -- Sam Hartman <hartmans@debian.org>  Thu, 16 Jan 2025 15:59:23 -0700

pam (1.5.3-7ubuntu6) questing; urgency=medium



=== debian/control ===
--- 
+++ 
@@ -1,21 +1,23 @@
 Source: pam
 Section: libs
 Priority: optional
-Maintainer: Sam Hartman <hartmans@debian.org>
-Uploaders: Steve Langasek <vorlon@debian.org>
-Standards-Version: 4.6.0
-Build-Depends: debhelper-compat (= 13), dh-exec, quilt, flex, libdb-dev, libcrypt-dev, libselinux1-dev [linux-any], po-debconf, dh-autoreconf, autopoint, libaudit-dev [linux-any] <!stage1>, pkg-config, libfl-dev, libfl-dev:native, docbook-xsl, docbook-xml, xsltproc, libxml2-utils, w3m
-Build-Conflicts-Indep: fop
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sam Hartman <hartmans@debian.org>
+Standards-Version: 4.7.0
+Build-Depends: debhelper-compat (= 13), dh-exec,  flex,  libcrypt-dev, libdb-dev, libselinux1-dev [linux-any], libsystemd-dev [linux-any] <!stage1>, po-debconf, meson, libaudit-dev [linux-any] <!stage1>, pkgconf, libfl-dev, libfl-dev:native
+Build-Depends-Indep: docbook-xsl-ns, docbook5-xml, xsltproc, libxml2-utils, w3m, fop
 Build-Conflicts: libdb4.2-dev, libxcrypt-dev
-Vcs-Browser: https://salsa.debian.org/vorlon/pam
-Vcs-Git: https://salsa.debian.org/vorlon/pam.git
+Vcs-Git: https://code.launchpad.net/~ubuntu-core-dev/ubuntu/+source/pam/+git/pam
+XS-Debian-Vcs-Browser: https://salsa.debian.org/vorlon/pam
+XS-Debian-Vcs-Git: https://salsa.debian.org/vorlon/pam.git
 Homepage: http://www.linux-pam.org/
 Rules-Requires-Root: binary-targets
 
 Package: libpam0g
 Architecture: any
 Multi-Arch: same
-Replaces: libpam0g-util
+Replaces: libpam0g-util, libpam0t64 (<< 1.5.3-5)
+Breaks: libpam0t64 (<< 1.5.3-5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: libpam-doc
@@ -58,8 +60,8 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}, debconf (>= 1.5.19) | cdebconf, libpam-modules (>= 1.0.1-6)
-Replaces: libpam0g-util, libpam0g-dev
-Conflicts: libpam0g-util
+Replaces: libpam-modules (<< 1.7.0), libpam-modules-bin (<< 1.7.0)
+Breaks: libpam-modules (<< 1.7.0), libpam-modules-bin (<< 1.7.0)
 Description: Runtime support for the PAM library
  Contains configuration files and  directories required for
  authentication  to work on Debian systems.  This package is required
@@ -71,6 +73,7 @@
 Multi-Arch: same
 Depends: ${misc:Depends}, libpam0g (= ${binary:Version}), libc6-dev|libc-dev
 Provides: libpam-dev
+Recommends: libpam-doc
 Description: Development files for PAM
  Contains C header files and development libraries for libpam, the Pluggable
  Authentication Modules, a library that enables the local system
@@ -82,20 +85,14 @@
 
 Package: libpam-doc
 Provides: pam-doc
+Build-Profiles: <!nodoc>
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
+Replaces: libpam0g-dev (<= 1.7.0)
+Breaks: libpam0g-dev (<= 1.7.0)
 Description: Documentation of PAM
  Contains documentation (in HTML, ASCII, and PostScript format) for libpam,
  the Pluggable Authentication Modules library, a library that enables the
  local system administrator to choose how applications authenticate users.
-
-Package: libpam-chksshpwd
-Section: admin
-Priority: optional
-Architecture: any
-Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}, libpam0g, libpam-runtime, gettext-base
-Description: PAM module to enable SSH password checking support
- This package includes libpam_chkpasswd, a PAM module that checks to see
- if the default password has been changed when SSH is enabled.

=== debian/rules ===
--- 
+++ 
@@ -21,23 +21,28 @@
 	dh $@
 
 
-# avoid libaudit-dev when bootstrapping
+# avoid libaudit-dev and libsystemd-dev when bootstrapping
 ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
-  CONFIGURE_OPTS += --disable-audit
+  meson_OPTS += -Daudit=disabled -Dlogind=disabled
+endif
+packages := $(shell dh_listpackages)
+
+ifneq (,$(filter libpam-doc libpam-runtime,$(packages)))
+meson_OPTS += -Ddocs=enabled
 endif
 
-CONFIGURE_OPTS += --enable-logind
 
 override_dh_auto_configure:
 	# Explicitly set libdir, sbindir to avoid upstream's override logic.
-	dh_auto_configure -- --enable-static --enable-shared \
+	dh_auto_configure  -- \
+--default-library=both \
 		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
 		--sbindir=/usr/sbin \
-		--enable-isadir=/usr/lib/security \
-		--with-systemdunitdir=/usr/lib/systemd/system \
-		--disable-nis \
-		--enable-usergroups \
-		$(CONFIGURE_OPTS)
+		-Disadir=/usr/lib/security \
+		-Dsystemdunitdir=/usr/lib/systemd/system \
+		-Dnis=disabled \
+		-Dusergroups=true \
+		$(meson_OPTS)
 	chmod 775 modules/pam_faillock/tst-pam_faillock
 
 # .install files don't have "except for" handling, so we need to exclude

## pam 2.0.0

=== DESCRIPTION ===
Package: pam
Type: Package
Title: Fast and Efficient Processing of PAM Data
Version: 2.0.0
Authors@R: c(
    person(
        "Julien",
        "Böhm",
        email = "julien.boehm@uni-rostock.de",
        role = c("cre", "aut"),
        comment = c(ORCID = "0009-0002-2704-2289")
    ),
    person(
        "Philipp",
        "Schrag",
        role = "aut",
        comment = c(ORCID = "0009-0002-7697-5536")
    )
    )
URL: https://github.com/biotoolbox/pam
BugReports: https://github.com/biotoolbox/pam/issues
Description: Processing Chlorophyll Fluorescence & P700 Absorbance data. Four models are provided for the regression of Pi curves, which can be compared with each other in order to select the most suitable model for the data set. Control plots ensure the successful verification of each regression. Bundled output of alpha, ETRmax, Ik etc. enables fast and reliable further processing of the data. 
License: GPL-3
Encoding: UTF-8
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3
RoxygenNote: 7.3.2
Imports: rlang, data.table, ggplot2, minpack.lm, cowplot, gridExtra,
        ggthemes, Metrics
NeedsCompilation: no
Packaged: 2026-02-01 10:19:02 UTC; julien
Author: Julien Böhm [cre, aut] (ORCID: <https://orcid.org/0009-0002-2704-2289>),
  Philipp Schrag [aut] (ORCID: <https://orcid.org/0009-0002-7697-5536>)
Maintainer: Julien Böhm <julien.boehm@uni-rostock.de>
Repository: CRAN
Date/Publication: 2026-02-01 10:40:02 UTC

## pam 2.0.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: pam
 Type: Package
 Title: Fast and Efficient Processing of PAM Data
-Version: 2.0.0
+Version: 2.0.2
 Authors@R: c(
     person(
         "Julien",
@@ -28,9 +28,9 @@
 Imports: rlang, data.table, ggplot2, minpack.lm, cowplot, gridExtra,
         ggthemes, Metrics
 NeedsCompilation: no
-Packaged: 2026-02-01 10:19:02 UTC; julien
+Packaged: 2026-02-23 18:35:08 UTC; desk
 Author: Julien Böhm [cre, aut] (ORCID: <https://orcid.org/0009-0002-2704-2289>),
   Philipp Schrag [aut] (ORCID: <https://orcid.org/0009-0002-7697-5536>)
 Maintainer: Julien Böhm <julien.boehm@uni-rostock.de>
 Repository: CRAN
-Date/Publication: 2026-02-01 10:40:02 UTC
+Date/Publication: 2026-02-23 19:10:02 UTC

## pam af-1.0.2

=== Makefile ===
# Copyright (c) 2004-2005 Stanislav Sedov <ssedov@mbsd.msk.ru>
# Copyright (c) 2005 MBSD labs
# Copyright (c) 2005 by 310.ru [Tridesyatoe], Moscow, Russian Federation
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: Makefile,v 1.12 2006/11/07 00:26:58 stas Exp $
#
# Parts of this file was derived from software distributed by Solar Designer
# under the following copyright:
#
#-------------------------------------------------------------------------
# Copyright (c) 2000-2003,2005 by Solar Designer.
#
# You're allowed to do whatever you like with this software (including        
# re-distribution in source and/or binary form, with or without
# modification), provided that credit is given where it is due and any
# modified versions are marked as such.  There's absolutely no warranty.
#-------------------------------------------------------------------------
#

.POSIX:

# C compiler
#CC = gcc
CC = cc
CC_GCC = gcc
CC_SUN = cc
CC_HP = cc

# Linker 
LD = $(CC)
LD_GCC = $(CC_GCC)
LD_SUN = $(CC_SUN)
LD_HP = $(CC_HP)

# Other stuff
RM = rm -f
MKDIR = mkdir -p
INSTALL = install -c
UNAME = uname -s

CFLAGS = -I./common/ -DPIC
# Uncoment this to use strict options
#CFLAGS_GCC =	-O2 -Wall -Wsystem-headers -Werror -Wno-format-y2k	\
#		-Wreturn-type -Wcast-qual -Wwrite-strings -Wswitch	\
#		-Wshadow -Wcast-align -Wunused-parameter		\
#		-Wchar-subscripts -Winline -Wnested-externs -fPIC
CFLAGS_GCC =	-O2 -Wall -Werror -Wno-format-y2k			\
		-Wreturn-type -Wcast-qual -Wwrite-strings -Wswitch	\
		-Wshadow -Wchar-subscripts -Winline -Wnested-externs -fPIC
CFLAGS_SUN = -KPIC -xO2 -D_SUN_PAM_ -D_HAVE_USERDEFS_H_
CFLAGS_HP = -Ae +w1 +W 474,486,542 +z +O2
CFLAGS_BSD = -D_HAVE_PATHS_H_ -D_HAVE_ERR_H_ -D_HAVE_GETPROGNAME_ -D_USE_MODULE_ENTRY_ -D_HAVE_SALEN_
CFLAGS_GNU =	-D_GNU_SOURCE -D_HAVE_PATHS_H_ -D_HAVE_ERR_H_ -D_HAVE_FLOCK_ \
		-D_HAVE_SYS_FILE_H_

LDFLAGS_BSD =
LDFLAGS_LINUX = -lgdbm -lgdbm_compat
LDFLAGS_SUN = -lnsl -lsocket
LDFLAGS_HP =
SHLDFLAGS_GCC = -s --shared -lpam -lcrypt
SHLDFLAGS_SUN = -s -G -lpam -lcrypt
SHLDFLAGS_HP = -s -b -lpam -lsec

LIBDIR = .
TOOLDIR = ./pam_af_tool
DISTLIB = pam_af.so
DISTTOOL = pam_af_tool
LIB = $(LIBDIR)/pam_af
TOOL = $(TOOLDIR)/pam_af_tool

LIBBIN = $(LIB).so
TOOLBIN = $(TOOL)

BINMODE = 755
MANMODE = 644

COMMSRC = common/subr.c common/subr.h common/pam_af.h
DISTLIBMAN = pam_af.8
DISTTOOLMAN = pam_af_tool.8
LIBMAN = $(LIBDIR)/$(DISTLIBMAN)
TOOLMAN = $(TOOLDIR)/$(DISTTOOLMAN)

SECUREDIR = /lib/security
SBINDIR = /sbin
MANDIR = /share/man
DESTDIR = /usr/local

LIB_OBJS = $(LIBDIR)/pam_af.o $(LIBDIR)/subr.o
TOOL_OBJS = $(TOOLDIR)/pam_af_tool.o $(TOOLDIR)/subr.o

all:
	if [ "`$(UNAME)`" = "FreeBSD" ]; then \
		$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_GCC) $(CFLAGS_BSD)" \
			LD=ld LDFLAGS="$(LDFLAGS_BSD) $(SHLDFLAGS_GCC)" \
			$(LIBBIN); \
		$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_GCC) $(CFLAGS_BSD)" \
			LDFLAGS="$(LDFLAGS_BSD)" $(TOOLBIN); \
	elif [ "`$(UNAME)`" = "Linux" ]; then \
		$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_GCC) $(CFLAGS_GNU)" \
			LD=ld LDFLAGS="$(LDFLAGS_LINUX) $(SHLDFLAGS_GCC)" \
			$(LIBBIN); \
		$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_GCC) $(CFLAGS_GNU)" \
			LDFLAGS="$(LDFLAGS_LINUX)" $(TOOLBIN); \
	elif [ "`$(UNAME)`" = "SunOS" ]; then \
		$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_SUN)" \
			LD=ld LDFLAGS="$(LDFLAGS_SUN) $(SHLDFLAGS_SUN)" \
			$(LIBBIN); \
		$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_SUN)" \
			LDFLAGS="$(LDFLAGS_SUN)" $(TOOLBIN); \
	elif [ "`$(UNAME)`" = "HP-UX" ]; then \
		$(MAKE) CFLAGS="$(CFLAGS_HP)" \
			LD=ld LDFLAGS="$(LDFLAGS_HP) $(SHLDFLAGS_HP)" \
			$(LIBBIN); \
		$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_HP)" \
			LDFLAGS="$(LDFLAGS_HP)" $(TOOLBIN); \
	else \
		$(MAKE) $(LIBBIN); \
		$(MAKE) $(TOOLBIN); \
	fi

$(LIBBIN): $(LIB_OBJS)
	$(LD) $(LDFLAGS) $(LIB_OBJS) -o $(LIBBIN)

$(TOOLBIN): $(TOOL_OBJS)
	$(CC) $(LDFLAGS) $(TOOL_OBJS) -o $(TOOLBIN)

$(LIBDIR)/subr.o:
	$(CC) $(CFLAGS) -DPAM_AF_DEFS -c ./common/$(*F).c -o $@
$(LIBDIR)/pam_af.o:
	$(CC) $(CFLAGS) -c $(LIBDIR)/$(*F).c -o $@
$(TOOLDIR)/pam_af_tool.o:
	$(CC) $(CFLAGS) -c $(TOOLDIR)/$(*F).c -o $@
$(TOOLDIR)/subr.o:
	$(CC) $(CFLAGS) -c ./common/$(*F).c -o $@

$(LIB).o: pam_af.c $(COMMSRC)
$(TOOL).o: pam_af_tool/pam_af_tool.c $(COMMSRC)

install:
	$(MKDIR) $(DESTDIR)$(SECUREDIR)
	$(MKDIR) $(DESTDIR)$(SBINDIR)
	$(MKDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m $(BINMODE) $(LIBBIN) $(DESTDIR)$(SECUREDIR)/$(DISTLIB)
	$(INSTALL) -m $(MANMODE) $(LIBMAN) \
		$(DESTDIR)$(MANDIR)/man8/$(DISTLIBMAN)
	$(INSTALL) -m $(BINMODE) $(TOOLBIN) $(DESTDIR)$(SBINDIR)/$(DISTTOOL)
	$(INSTALL) -m $(MANMODE) $(TOOLMAN) \
		$(DESTDIR)$(MANDIR)/man8/$(DISTTOOLMAN)

deinstall:
	$(RM) $(DESTDIR)$(SECUREDIR)/$(DISTLIB)
	$(RM) $(DESTDIR)$(SBINDIR)/$(DISTTOOL)
	$(RM) $(DESTDIR)$(MANDIR)/man8/$(DISTLIBMAN)
	$(RM) $(DESTDIR)$(MANDIR)/man8/$(DISTTOOLMAN)

clean:
	$(RM) $(LIBBIN) $(TOOLBIN) $(LIB_OBJS) $(TOOL_OBJS)

## pam authsrv

=== Makefile ===
#
# This Makefile controls a build process of $(TITLE) module for
# Linux-PAM. You should not modify this Makefile (unless you know
# what you are doing!).
#

TITLE=pam_authsrv

#

LIBSRC = $(TITLE).c
LIBOBJ = $(TITLE).o
LIBOBJD = $(addprefix dynamic/,$(LIBOBJ))
LIBOBJS = $(addprefix static/,$(LIBOBJ))

dynamic/%.o : %.c
	$(CC) $(CFLAGS) $(DYNAMIC) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@

static/%.o : %.c
	$(CC) $(CFLAGS) $(STATIC) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@


ifdef DYNAMIC
LIBSHARED = $(TITLE).so
endif

ifdef STATIC
LIBSTATIC = lib$(TITLE).o
endif

####################### don't edit below #######################

dummy:

	@echo "**** This is not a top-level Makefile "
	exit

all: dirs $(LIBSHARED) $(LIBSTATIC) register

dirs:
ifdef DYNAMIC
	$(MKDIR) ./dynamic
endif
ifdef STATIC
	$(MKDIR) ./static
endif

register:
ifdef STATIC
	( cd .. ; ./register_static $(TITLE) $(TITLE)/$(LIBSTATIC) )
endif

ifdef DYNAMIC
$(LIBOBJD): $(LIBSRC)

$(LIBSHARED):	$(LIBOBJD)
	$(LD_D) -o $@ $(LIBOBJD)
endif

ifdef STATIC
$(LIBOBJS): $(LIBSRC)

$(LIBSTATIC): $(LIBOBJS)
	$(LD) -r -o $@ $(LIBOBJS)
endif

install: all
	$(MKDIR) $(FAKEROOT)$(SECUREDIR)
ifdef DYNAMIC
	$(INSTALL) -m $(SHLIBMODE) $(LIBSHARED) $(FAKEROOT)$(SECUREDIR)
endif

remove:
	rm -f $(FAKEROOT)$(SECUREDIR)/$(TITLE).so

clean:
	rm -f $(LIBOBJD) $(LIBOBJS) core *~

extraclean: clean
	rm -f *.a *.o *.so *.bak dynamic/* static/*

.c.o:	
	$(CC) $(CFLAGS) -c $<

## pam cap-0.1

=== Makefile ===
# simple make file for the pam_cap module

pam_cap.so: pam_cap.o
	ld -x --shared -o pam_cap.so $< -lcap

pam_cap.o: pam_cap.c
	$(CC) -fPIC -c $<

test: test.c pam_cap.o
	$(CC) -o test test.c pam_cap.o -lpam -ldl -lcap

clean:
	rm -f *.o *.so test

## pam chroot-0.6

=== Makefile ===
# $Id$

CC=gcc
CFLAGS=-fPIC -O2 -Wall -Werror -pedantic
CPPFLAGS=-I.
LDFLAGS=-x --shared -lpam

OUT=pam_chroot.so

all:	$(OUT)

%.so: %.o
	ld $(LDFLAGS) -o $@ $<

clean:
	rm -f *.o $(OUT)

install:
	install -s -o0 -g0 -m755 $(OUT) /lib/security

## pam client-0.1.0

=== Makefile ===
INSTALL	:= install
DESTDIR	:=
PIC	:= -fPIC
LD_D	:= $(CC) -shared
CFLAGS	:=
SHARE	:= -g $(PIC)


pam_client: pam_client.c
	$(CC) $(CFLAGS) $(SHARE) -c pam_client.c -o pam_client.o
	$(LD_D)  -o pam_client.so pam_client.o  -lc -lpam

clean: pam_client.so pam_client.o
	$(RM) pam_client.o
	$(RM) pam_client.so
	
install: pam_client.so
	$(INSTALL) -D -m 0755 pam_client.so $(DESTDIR)/lib/security/pam_client.so

uninstall: $(DESTDIR)/lib/security/pam_client.so
	$(RM) $(DESTDIR)/lib/security/pam_client.so

## pam client-0.2.0

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 pam_client: pam_client.c
 	$(CC) $(CFLAGS) $(SHARE) -c pam_client.c -o pam_client.o
-	$(LD_D)  -o pam_client.so pam_client.o  -lc -lpam
+	$(LD_D)  -o pam_client.so pam_client.o  -lc -lpam -lldap
 
 clean: pam_client.so pam_client.o
 	$(RM) pam_client.o

## pam delay

=== Makefile ===
CFLAGS += -Wall -Wpointer-arith -Wwrite-strings -Wstrict-prototypes 
CFLAGS += -Wnested-externs
CFLAGS += -g -fPIC
LDFLAGS += -shared -lpam

OBJS=pam_delay.o
LIB=pam_delay.so

all: $(LIB)

$(LIB): $(OBJS)
	$(LINK.c) $(OBJS) -o $@

## pam dpasswd

=== Makefile ===
# $Header: /home/walid/PAM/pam_dpasswd/RCS/Makefile,v 1.1 1998/04/24 21:52:35 walid Exp walid $
#
# $Log: Makefile,v $
# Revision 1.1  1998/04/24 21:52:35  walid
# Initial revision
#
#

# Adopted from the PAM distribution with some modifications.
# This is free software. use at your own risk.
#
# Walid Harmoush 
#

FAKEROOT=
SECUREDIR=/lib/security
SHLIBMODE=0644

CFLAGS=-O7 -pipe -g

LD_D=gcc -shared -Xlinker -x

LIBAUTHSH = pam_auth_dpasswd.so

LIBAUTHOBJ = pam_auth_dpasswd.o dialup.o 
LIBAUTHSRC = pam_auth_dpasswd.c dialup.c

LIBOBJ = $(LIBAUTHOBJ)
LIBSRC = $(LIBAUTHSRC)

LIBSHARED = $(LIBAUTHSH)

LIBOBJD = $(addprefix dynamic/,$(LIBOBJ))

all: dirs $(LIBSHARED)

dirs:
	mkdir -p ./dynamic

$(LIBOBJD): $(LIBSRC)

$(LIBAUTHSH):	$(LIBAUTHSRC) $(LIBOBJD)
		$(LD_D) -o $@ $(addprefix dynamic/,$(LIBAUTHOBJ))

install: all
	mkdir -p $(FAKEROOT)$(SECUREDIR)
	install -m $(SHLIBMODE) $(LIBSHARED) $(FAKEROOT)$(SECUREDIR)
	ldconfig $(FAKEROOT)$(SECUREDIR)

remove:
	cd $(FAKEROOT)$(SECUREDIR) && rm -f $(LIBSHARED)

clean:
	rm -f $(LIBOBJD) $(LIBOBJS) a.out core *~

extraclean: clean
	rm -f *.a *.out *.o *.so *.bak

.c.o:	
	$(CC) -c $(CFLAGS) $<

dynamic/%.o : %.c
	$(CC) $(CFLAGS) $(DYNAMIC) $(CPPFLAGS) -c $< -o $@
